/**
 * Copyright (c) Cisco Systems, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
import { Icon } from "../icon/Icon";
import { PlacementType } from "../popover/Popover.types";
import "../progress-bar/ProgressBar";
import "../tooltip/Tooltip";
import { LitElement, nothing, PropertyValues } from "lit";
export declare namespace Chip {
    type Role = "group" | "option" | "button";
    type Placement = PlacementType;
    class ELEMENT extends LitElement {
        color: string;
        bgColor: string;
        textColor: string;
        height: string;
        icon: string;
        iconColor: string;
        iconSize: string | undefined;
        role: Chip.Role;
        id: string;
        small: boolean;
        readonly: boolean;
        selected: boolean;
        disabled: boolean;
        determinateProgress: number;
        indeterminateProgress: boolean;
        tooltipText: string;
        tooltipPlacement: Chip.Placement;
        iconSet: Icon.IconSet | undefined;
        suppressDefaultMaxWidth: boolean;
        decorative: boolean;
        shouldTruncateValue: boolean;
        value: string;
        private textOverflow;
        private renderedText;
        connectedCallback(): void;
        protected willUpdate(changedProperties: PropertyValues): void;
        getTextWidth(text: string, font?: string): number;
        MAXWIDTH: number;
        truncStringPortion(text: string): void;
        protected selectionChange: (newState: boolean) => void;
        handleClear: (chipId: string) => void;
        handleSelect: () => void;
        handleDeSelect: () => void;
        handleClick(): void;
        protected handleKeydown(event: KeyboardEvent): void;
        protected renderBgColor: () => string | typeof nothing;
        protected renderTextColor: () => string | typeof nothing;
        protected renderHeight: () => string | typeof nothing;
        protected getStyles: () => import("lit-html").TemplateResult<1> | typeof nothing;
        static get styles(): import("lit").CSSResult[];
        protected loadingTemplate(): import("lit-html").TemplateResult<1> | typeof nothing;
        protected iconTemplate(): import("lit-html").TemplateResult<1> | typeof nothing;
        getToolTipContent(): string;
        private get textContentClassMap();
        private get textContentTemplate();
        render(): import("lit-html").TemplateResult<1>;
    }
}
declare global {
    interface HTMLElementTagNameMap {
        "md-chip": Chip.ELEMENT;
    }
}
